from __future__ import annotations

import os
import os.path
from glob import glob

import pkg_resources
from tutor import hooks

from .__about__ import __version__

########################################
# CONFIGURATION
########################################

hooks.Filters.CONFIG_DEFAULTS.add_items(
    [
        # Add your new settings that have default values here.
        # Each new setting is a pair: (setting_name, default_value).
        # Prefix your setting names with 'MOGC_POLICY_'.
        ("MOGC_POLICY_VERSION", __version__),
        ("MOGC_POLICY_REQUIREMENT_SPECIFIER", "mogc-policy==0.1.0"),
        ("MOGC_POLICY_INDEX_URL", "https://packages.ai.umich.edu"),
    ]
)


########################################
# PATCH LOADING
# (It is safe & recommended to leave
#  this section as-is :)
########################################

# For each file in tutor_mogc_policy/patches,
# apply a patch based on the file's name and contents.
for path in glob(
    os.path.join(
        pkg_resources.resource_filename("tutor_mogc_policy", "patches"),
        "*",
    )
):
    with open(path, encoding="utf-8") as patch_file:
        hooks.Filters.ENV_PATCHES.add_item((os.path.basename(path), patch_file.read()))
